unit EditFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cad, ExtCtrls, StdCtrls, jpeg, Buttons,MainFrm, ExtDlgs;

type
  TEditForm = class(TForm)
    Panel1: TPanel;
    CADEdit: TMyCAD;
    edtName: TEdit;
    Image1: TImage;
    bbtnOK: TBitBtn;
    bbtnCancel: TBitBtn;
    Panel2: TPanel;
    sbtnLine: TSpeedButton;
    sbtnRuleLine: TSpeedButton;
    sbtnSelecting: TSpeedButton;
    sbtnRotateSelecting: TSpeedButton;
    sbtnLineLinkLine: TSpeedButton;
    sbtnLinkLine: TSpeedButton;
    sbtnPolyLine: TSpeedButton;
    sbtnPolygon: TSpeedButton;
    sbtnRectangle: TSpeedButton;
    sbtnEllipse: TSpeedButton;
    sbtnText: TSpeedButton;
    sbtnImage: TSpeedButton;
    sbtnElliArc: TSpeedButton;
    sbtnPolyBezier: TSpeedButton;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure bbtnCancelClick(Sender: TObject);
    procedure bbtnOKClick(Sender: TObject);
    procedure CADEditShapeAdded(var AShape: TMyShape; ShapeCount: Integer);
    procedure sbtnLineClick(Sender: TObject);
    procedure sbtnSelectingClick(Sender: TObject);
    procedure sbtnRotateSelectingClick(Sender: TObject);
    procedure sbtnRuleLineClick(Sender: TObject);
    procedure sbtnPolyLineClick(Sender: TObject);
    procedure sbtnPolygonClick(Sender: TObject);
    procedure sbtnRectangleClick(Sender: TObject);
    procedure sbtnEllipseClick(Sender: TObject);
    procedure sbtnElliArcClick(Sender: TObject);
    procedure sbtnPolyBezierClick(Sender: TObject);
    procedure sbtnTextClick(Sender: TObject);
    procedure sbtnImageClick(Sender: TObject);
    procedure sbtnLineLinkLineClick(Sender: TObject);
    procedure sbtnLinkLineClick(Sender: TObject);
    procedure CADEditActionToolToSelecting;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EditForm: TEditForm;

implementation


{$R *.dfm}

procedure TEditForm.bbtnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TEditForm.bbtnOKClick(Sender: TObject);
var
  ms:TMemoryStream;
begin
  ms:=TMemoryStream.Create;
  CADEdit.SaveToStream(ms);
  if CADEdit.Tag=1 then
    MainForm.Table1.Insert
  else
    MainForm.Table1.Edit;

  MainForm.Table1.FieldByName('Name').AsString:=edtName.Text;
  MainForm.Table1.FieldByName('LastUpdate').AsDateTime:=Now;
  MainForm.Table1Draw.LoadFromStream(ms);
  MainForm.Table1.Post;
  ms.Free;
  MainForm.LoadDraw;
  ShowMessage('Save success!');
  Close;
end;

procedure TEditForm.CADEditShapeAdded(var AShape: TMyShape;
  ShapeCount: Integer);
var
  ABitmap:TBitmap;
begin
  CADEdit.ReleaseCursorClipArea;
  if AShape <> nil then
    if AShape.ClassName = 'TMyImage' then
      if OpenPictureDialog1.Execute then
      begin
        ABitmap:=  LoadGraphicsFile(OpenPictureDialog1.FileName);
        CADEdit.SetMyImage(AShape.ShapeId,ABitmap) ;
        ABitmap.Free;
      end;
end;

procedure TEditForm.sbtnLineClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpLine;
end;

procedure TEditForm.sbtnSelectingClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpSelecting;
end;

procedure TEditForm.sbtnRotateSelectingClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpRotateSelecting;
end;

procedure TEditForm.sbtnRuleLineClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpRuleLine;
end;

procedure TEditForm.sbtnPolyLineClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpPolyLine;
end;

procedure TEditForm.sbtnPolygonClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpPolygon;
end;

procedure TEditForm.sbtnRectangleClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpRectangle;
end;

procedure TEditForm.sbtnEllipseClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpEllipse;
end;

procedure TEditForm.sbtnElliArcClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpElliArc;
end;

procedure TEditForm.sbtnPolyBezierClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpPolyBezier;
end;

procedure TEditForm.sbtnTextClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpText;
end;

procedure TEditForm.sbtnImageClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpImage;
end;

procedure TEditForm.sbtnLineLinkLineClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpLineLinkLine;
end;

procedure TEditForm.sbtnLinkLineClick(Sender: TObject);
begin
  CADEdit.ShapeTool:=SpLinkLine;
end;

procedure TEditForm.CADEditActionToolToSelecting;
begin
  sbtnSelecting.Down:=true;
end;

end.
